Redmine - Feature #29752

Render Textile and Markdown attachments on the preview page
2018-10-10 06:42 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Attachments Estimated time: 0.00 hour
Target version: 4.1.0

Resolution: Fixed

Description

Currently, Textile and Markdown files are treated as plain text when previewing an attachment.

I think it is more convenient for users to render those as HTML as if they are written in a Wiki page. Raw markups such as "h1.",
"h2.", and "h3." are not friendly for humans.

Related issues:

Related to Redmine - Feature #13431: it would be nice to render the markup la... Closed
Related to Redmine - Feature #16849: Render Textile and Markdown files in the... Closed
Related to Redmine - Feature #35889: Textile and Markdown attachment renderin... New

Associated revisions

Revision 18584 - 2019-10-03 02:09 - Go MAEDA

Render Textile and Markdown attachments on the preview page (#29752).

Patch by Takenori TAKAKI.

Revision 18585 - 2019-10-03 02:32 - Go MAEDA
Add styles for Textile/Markdown attachments preview (#29752).

Patch by Go MAEDA.

Revision 18586 - 2019-10-03 11:30 - Go MAEDA
Use Redmine::MimeType.of instead of regexp to check if the attachment is Textile (#29752).

History

#1 - 2018-10-10 07:41 - Go MAEDA

- Related to Feature #13431: it would be nice to render the markup language in the "Repository" view added

#2 - 2018-10-16 08:15 - Takenori TAKAKI
- File 29752.patch added

+1
I think it is very useful that the feature proposed by Go MAEDA.
| made a patch to add the feature, and attach it.

#3 - 2018-12-01 09:30 - Go MAEDA

- Target version set to 4.1.0

LGTM. Setting the target version to 4.1.0.

#4 - 2019-05-03 09:51 - Go MAEDA
- Related to Feature #16849: Render Textile and Markdown files in the repository browser added

#5 - 2019-09-28 13:52 - Marius BALTEANU

- Status changed from New to Needs feedback
The patch looks good to me with one small observation, do you see any problem if we add 'text/textile’ => 'textile' to MIME_TYPES? In this way, we
can replace in the patch self.filename =~ A.(textile)$/i with Redmine::MimeType.of(filename) == "text/textile".

#6 - 2019-09-28 14:08 - Marius BALTEANU
- Assignee set to Go MAEDA

#7 - 2019-10-02 17:47 - Go MAEDA
- File add-border-before@2x.png added
- File add-border-after@2x.png added

| suggest adding the following change to the patch in order to make distinguishable between the Ul of Redmine and the content of the file by adding a
border around the content.

diff --git a/app/views/common/_markup.html.erb b/app/views/common/_markup.html.erb
index dc6c7f474..14786a87c 100644
--— a/app/views/common/_markup.html.erb
+++ b/app/views/common/_markup.html.erb
@@ -1,3 +1,3 @@
—-<div class="wiki">
+<div class="filecontent wiki">
<%= Redmine::WikiFormatting.to_html (markup_text_formatting, Redmine::CodesetUtil.to_utf8_by_setting (markup_
text)) .html_safe %>
</div>
diff --git a/public/stylesheets/application.css b/public/stylesheets/application.css
index 5f8adel06..8c9402142 100644
—-—— a/public/stylesheets/application.css
+++ b/public/stylesheets/application.css
@@ -1740,6 +1740,13 @@ img {
max-width: 100%;
}

+.filecontent-container > .filecontent.wiki {
+ position: relative;

+ Dborder: lpx solid #e2e2e2;

+ padding: 8px;

+ Dborder-radius: 3px;

+
L

}

/* Fixes for IE 11 */
@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {
select::—-ms—expand {
Bug #22 » 2_2_release_notes.md ¥ Download (22.6 KB)

Redmine Admin, 10/03/2019 12:21 AM

Ruby on Rails 2.2 Release Notes

Rails 2.2 delivers a number of new and improved features. This list covers the major upgrades, but doesn't include every little bug fix and change.
If you want to see everything, check out the 7 list of commits in the main Rails repository on GitHub.

Along with Rails, 2.2 marks the launch of the 7 Ruby on Rails Guides, the first results of the ongoing 7' Rails Guides hackfest. This site will deliver
high-quality documentation of the major features of Rails.

Infrastructure

Rails 2.2 is a significant release for the infrastructure that keeps Rails humming along and connected to the rest of the world.
#8 - 2019-10-03 02:33 - Go MAEDA
- Status changed from Needs feedback to Closed

- Resolution set to Fixed

Committed the patch. Thank you all for contributing and reviewing the patch.

#9 - 2019-10-03 02:53 - Go MAEDA

- Subject changed from Render Textile and Markdown attachments as HTML on the preview page to Render Textile and Markdown attachments on
the preview page

#10 - 2019-10-03 03:04 - Mischa The Evil
Go MAEDA wrote:

Committed the patch. [...]

What about the note Marius made in #29752#note-5?

#11 - 2019-10-03 03:36 - Go MAEDA
- Status changed from Closed to Reopened
Mischa The Evil wrote:

What about the note Marius made in #29752#note-5?

Oh, | forgot to handle that. Thank you for pointing it out.
Marius BALTEANU wrote:
The patch looks good to me with one small observation, do you see any problem if we add 'text/textile’ => 'textile' to MIME_TYPES? In this way,

we can replace in the patch self.filename =~ /\.(textile)$/i with Redmine::MimeType.of(filename) == "text/textile".

| like the approach but there is only one problem that "text/textile" is not a valid media type (see
https://www.iana.or ignments/media- media- xhtml). Maybe we can use "text/x-textile" instead, what do you think?

#12 - 2019-10-03 08:47 - Marius BALTEANU
Go MAEDA wrote:
Marius BALTEANU wrote:

The patch looks good to me with one small observation, do you see any problem if we add 'text/textile’' => 'textile' to MIME_TYPES? In this
way, we can replace in the patch self.filename =~ /\.(textile)$/i with Redmine::MimeType.of(filename) == "text/textile".
| like the approach but there is only one problem that "text/textile" is not a valid media type (see
https://www.iana.org/assignments/media-types/media-types.xhtml). Maybe we can use "text/x-textile" instead, what do you think?

| like your idea to use "text/x-textile".

#13 - 2019-10-03 09:01 - Go MAEDA

This patch replaces the regexp that checks ".textile' extension with Redmine::MimeType.of.

Index: app/models/attachment.rb

-—— app/models/attachment.rb (00000 18585)
+++ app/models/attachment.rb oooon)
@@ -245,7 +245,7 Q@@

end

def is_textile?

* self.filename =~ /\.textile$/i
+ Redmine: :MimeType.of (filename) == 'text/x-textile'
end

def is_image?
Index: lib/redmine/mime_type.rb

——— lib/redmine/mime_type.rb (00000 18585)

+++ lib/redmine/mime_type.rb (oooon)y

@@ -35,6 +35,7 @@

'text/x-ruby' => 'rb, rbw, ruby, rake,erb’,
'text/x-csh' => 'csh',
'text/x-sh' => 'sh',

+ 'text/x-textile' => 'textile',
'text/xml' => 'xml,xsd,mxml',
'text/yaml' => 'yml,yaml',

'text/csv' => 'csv',

#14 - 2019-10-03 11:31 - Go MAEDA

- Status changed from Reopened to Closed

Committed the patch #29752#note-13 in r18586.

#15 - 2021-09-18 13:03 - Mischa The Evil
- Related to Feature #35889: Textile and Markdown attachment rendering should support third-party formatters added

Files

29752.patch 4.14 KB 2018-10-16 Takenori TAKAKI
add-border-before@2x.png 68.8 KB 2019-10-02 Go MAEDA
add-border-after@2x.png 69 KB 2019-10-02 Go MAEDA

2025-08-23 4/4


https://www.iana.org/assignments/media-types/media-types.xhtml
https://www.redmine.org/issues/29752#note-13
https://www.redmine.org/projects/redmine/repository/svn/revisions/18586
http://www.tcpdf.org

